﻿package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.filters.BlurFilter;
	import flash.geom.Matrix;
	import flash.geom.Point;
	public class Sinuser extends Sprite
	{
		private var bmp:BitmapData;
		private var angle:uint = 0;
		private var support:Sprite = new Sprite();
		private var filterObj:BlurFilter = new BlurFilter(1.2,1.2,2);
		private var colors:Array = [0x00ccff,0xffffff,0x00ff99];
		
		
		public function Sinuser()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		private function addedHandler(e:Event):void
		{
			bmp = new BitmapData(stage.stageWidth,stage.stageHeight,false,0x000000);
			addChild(new Bitmap(bmp));
			stage.addEventListener(MouseEvent.MOUSE_MOVE,enterHandler);
		}
		private function buildCycle(target:Sprite,angle:uint):Sprite
		{	
			var point:Sprite = new Sprite();
			point.graphics.beginFill(colors[angle%3],1);
			point.graphics.drawCircle(0,0,5);
			point.graphics.endFill();
			target.addChild(point);
			point.x += Math.cos(angle/180*Math.PI)*30;
			point.y += Math.sin(angle/180*Math.PI)*30;
			return point;
			
			
			
		}
		private function enterHandler(e:Event):void
		{
			var basis:Sprite = new Sprite();
			basis.x = stage.stageWidth/2;
			basis.y = stage.stageHeight/2;
			support.addChild(basis);
			for(var i:uint=0;i<200;i++){
				basis = buildCycle(basis,angle*i+500);
			}
			var m:Matrix = new Matrix();
			m.rotate(angle/35*mouseX); //vitesse
			m.translate(stage.stageWidth*2,stage.stageHeight*2);
			m.scale(0.25,0.25);
			if(angle%30 == 0){
				bmp.applyFilter(bmp,bmp.rect,new Point(0,0),filterObj);
			}
			bmp.draw(support,m);
			support.removeChildAt(0);
			angle++;
		
		}
		
		
	}
}